#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

out vec2 fragmentUV;
out vec3 P;
out vec3 N;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;

void main(){
	
	fragmentUV = uv;
	mat4 normalMatrix = inverse(transpose(modelMatrix));
	vec3 worldNormal = normalize( (normalMatrix * vec4(normal, 0)).xyz );
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);

	N = normalize(worldNormal);
	P = ( modelMatrix * vec4(position, 1) ).xyz;

}