#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;
in vec3 color;


out vec2 fragmentUV;
out vec3 P;
out vec3 N;
out vec3 V;
out vec3 C;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform vec3 cameraPosition;



void main(){
	
	fragmentUV = uv;
	vec3 worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
	
	N = worldNormal;
	P = ( modelMatrix * vec4(position, 1) ).xyz;
	V = normalize(cameraPosition - P);
	C = color;

}